/*
 *  Copyright (C) 2016-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCAUTOSARiAUTomotive Open System ARchitecturejd
 *  lɊÂĂDL̋́CAUTOSAR̒mIŶ
 *  ͂ȂDAUTOSAŔCAUTOSARdlɊÂ\tgEFApړIŗ
 *  p҂ɑ΂āCAUTOSARp[gi[ɂȂ邱Ƃ߂ĂD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 */

#include "CommunicationServices.h"
#include "CsStub.h"

#define CS_STUB_E_OK		(0U)
#define CS_STUB_E_NOT_OK	(1U)

/*
 *  n : CANM
 */
#define BODYCMD_CANMSG_SEND_CYCLE_MS	100

/*
 *  CommunicationServicesX^u̎
 */
#define SS_STUB_CYCLE_MS		10

/*
 *  
 */
void
CsStubPeriodicHook(void)
{
	static uint32	canmsg_snd_cycle = 0;
	
	/*  {fBnECUCANM */
	if (canmsg_snd_cycle-- == 0) {
		SendBodyCmdCanMag();
		canmsg_snd_cycle = (BODYCMD_CANMSG_SEND_CYCLE_MS/SS_STUB_CYCLE_MS);
	}
}

/*
 *  MMv
 */
uint8
Com_SendSignal(Com_SignalIdType SignalId, const void *SignalDataPtr)
{
	uint8	ercd = E_OK;
	
	switch (SignalId) {
	case ComConf_ComSignal_ComSignal0:
		g_bodycmd.winker = *((const uint8 *) SignalDataPtr);
		break;
	case ComConf_ComSignal_ComSignal1:
		g_bodycmd.buzzer = *((const uint8 *) SignalDataPtr);
		break;
	case ComConf_ComSignal_ComSignal2:
		g_bodycmd.backlamp = *((const boolean *) SignalDataPtr);
		break;
	case ComConf_ComSignal_ComSignal3:
		g_bodycmd.brakelamp = *((const boolean *) SignalDataPtr);
		break;
	case ComConf_ComSignal_ComSignal4:
		g_bodycmd.headlamp = *((const boolean *) SignalDataPtr);
		break;
	case ComConf_ComSignal_ComSignal5:
		g_bodycmd.foglamp = *((const boolean *) SignalDataPtr);
		break;
	default:
		ercd = E_NOT_OK;
		break;
	}
	
	return(ercd);
}

