/*
 *  Copyright (C) 2014-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2014-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 *
 *  ܥեȥϡAUTOSARAUTomotive Open System ARchitecture˻
 *  ͤ˴ŤƤ롥嵭εϡAUTOSARŪ⻺Τ
 *  ϤʤAUTOSARϡAUTOSARͤ˴ŤեȥŪ
 *  ѤԤФơAUTOSARѡȥʡˤʤ뤳ȤƤ롥
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 *
 *  $Id: CddController.c 814 2017-03-10 07:11:37Z fsi-masayam $
 */  

/*
 *		CDD SW-C CddControllerѤε
 */

#include "Rte_CddController.h"
#include "ModelCarControl.h"
#include "t_syslog.h"
#include "rcb3.h"

/*
 *  CDD SW-C CddControllerѤν
 */
void
CddControllerInit(void)
{
	tInitSBDBTUart();
	rcb3_Init();
}

/* ⡼ */
typedef enum {
	RX_MODE_INIT,
	RX_MODE_RCB3,
} rx_mode_type;

/* TRUEǽ뤳Ȥͤʤ褦ˤ */
static IDT_RCB3		RCB3CommandData;
static boolean		RCB3CommandGotFlg = TRUE;

static rx_mode_type rx_mode = RX_MODE_INIT;

/*
 *  RunnableEntity(ڥ졼ƽФ)
 */
void
GetRCB3Command(IDT_RCB3 *command)
{
	if (RCB3CommandGotFlg == FALSE) {
		*command = RCB3CommandData;
		RCB3CommandGotFlg = TRUE;
	}
	else {
		*command = NOT_RECEIVE_COMMAND;
	}
}

/*
 *  MessageParserʥ֥
 */
void
MessageParser(void)
{
	uint8 c;

	while (tReceiveSBDBTUart(&c, 1)) {
		switch (rx_mode) {
		case RX_MODE_INIT:
			if (c == RCB3_MSG_HEADER_1) {
				/* RCB3ǡ */
				(void) rcb3_AddReceivedByte(c);
				rx_mode = RX_MODE_RCB3;
			}
			else {
				syslog(LOG_INFO, "## Header Error (0x%x)", c);
			}
			break;
		case RX_MODE_RCB3:
			if (rcb3_AddReceivedByte(c)) {
				/* RCB3ǡλ */
				RCB3CommandData = (IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_L];         /* ܥ1 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_BUTTON_H]) << 8U;/* ܥ2 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_L_ANALOG_LR]) << 16U;  /* ʥ1 */
				RCB3CommandData += ((IDT_RCB3) g_rcb3_rmsg[RCB3_MSG_OFFSET_R_ANALOG_UD]) << 24U;  /* ʥ4 */
				RCB3CommandGotFlg = FALSE;
				rx_mode = RX_MODE_INIT;
			}
			break;
		}
	}
}

/*
 *  rcb3_AddReceivedByteΥ顼Хå
 */
void
rcb3_ErrorCb(uint8 sum, uint8 recv_sum, uint8 *p_rcb3_rmsg)
{
	uint32 i;

	rx_mode = RX_MODE_INIT;
	syslog(LOG_INFO, "## RCB3 Sum Error: 0x%x != 0x%x", sum, recv_sum);
	for (i = 0; i < RCB3_MSG_LEN; i++) {
		syslog(LOG_INFO, "## rcb3_rmsg[%d]: 0x%x", i, p_rcb3_rmsg[i]);
	}
}
