/*
 *  Copyright (C) 2016-2017 by Center for Embedded Computing Systems
 *                             Graduate School of Information Science, Nagoya Univ., JAPAN
 *  Copyright (C) 2016-2017 by FUJI SOFT INCORPORATED, JAPAN
 *  Copyright (C) 2016-2017 by NEC Communication Systems, Ltd., JAPAN
 *  Copyright (C) 2016-2017 by SCSK Corporation, JAPAN
 *  Copyright (C) 2016-2017 by SUZUKI MOTOR CORPORATION 
 *  Copyright (C) 2016-2017 by TOSHIBA CORPORATION, JAPAN
 *  Copyright (C) 2016-2017 by Witz Corporation
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCAUTOSARiAUTomotive Open System ARchitecturejd
 *  lɊÂĂDL̋́CAUTOSAR̒mIŶ
 *  ͂ȂDAUTOSAŔCAUTOSARdlɊÂ\tgEFApړIŗ
 *  p҂ɑ΂āCAUTOSARp[gi[ɂȂ邱Ƃ߂ĂD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  $Id: SystemServices_cfg.c 814 2017-03-10 07:11:37Z fsi-masayam $
 */

/*
 *		SystemServicesRtBOvO
 */
#include "Std_Types.h"
#include "t_syslog.h"
#include "driver_if.h"
#include "Com.h"
#include "CanIf.h"
#include "Can.h"
#include "ModelCarControl.h"
#include "SystemServices.h"

/*
 *  tbN
 */
void
InitHook(void)
{
	Std_ReturnType		ercd = E_OK;
	Com_IpduGroupVector	vector_on;

	/* dipsw̏ */
	switch_dip_init();

	/*
	 * COMX^bNN
	 */
	/* CanW[ */
	Can_Init(NULL_PTR);

	/* CanIfW[ */
	CanIf_Init(NULL_PTR);
	/* CanIfW[X^[gAbv */
	ercd = CanIf_SetControllerMode(0U, CANIF_CS_STARTED);
	if (ercd != E_OK) {
		syslog(LOG_NOTICE, "## CanIf_SetControllerMode returns E_NOT_OK !!");
	}
	ercd = CanIf_SetPduMode(0U, CANIF_SET_ONLINE);
	if (ercd != E_OK) {
		syslog(LOG_NOTICE, "## CanIf_SetPduMode returns E_NOT_OK !!");
	}

	/* ComW[ */
	Com_Init(NULL_PTR);
	/* ComW[X^[gAbv */
	Com_SetIpduGroup(vector_on, 0, TRUE);
	Com_IpduGroupControl(vector_on, TRUE);

	/* LedBlinker֘Ȁ */
	LedBlinkerInit();

	/* {fBnɊւ鏉 */
	BodyControlInit();

	return;
}

/*
 *  ^XNi10msNj
 */
void
HighTaskHook(void)
{
	/* COM̎M̒ */
	Com_MainFunctionRx();

	return;
}

/*
 *  ^XNi100msNj
 */
void
LowTaskHook(void)
{
	/* {[hLED̓_̒ */
	LedBlinkerHook();

	/* {fBn̒ */
	BodyControlPeriodicHook();

	return;
}

/*
 *  荞ݏi125sNj
 */
void
BuzzerTaskHook(void)
{
	/* uU[ */
	BuzzerControl();

	return;
}

